header.h
Go to the documentation of this file.
#ifndef H_HEADER
#define H_HEADER
/* RPM - Copyright (C) 1995-2001 Red Hat Software */
#include <rpm/rpmio.h>
#include <rpm/rpmtypes.h>
#include <rpm/rpmtd.h>
#include <rpm/rpmutil.h>
#ifdef __cplusplus
extern "C" {
#endif
extern const unsigned char rpm_header_magic[8];
enum hMagic {
HEADER_MAGIC_NO = 0,
HEADER_MAGIC_YES = 1
};
Header headerNew(void);
Header headerFree( Header h);
Header headerLink(Header h);
void headerSort(Header h);
void headerUnsort(Header h);
unsigned int headerSizeof(Header h, int magicp);
int headerVerifyInfo(int il, int dl, const void * pev, void * iv, int negate);
void * headerUnload(Header h);
void * headerExport(Header h, unsigned int * bsize);
Header headerReload(Header h, rpmTagVal tag);
Header headerCopy(Header h);
Header headerLoad(void * uh);
Header headerCopyLoad(const void * uh);
enum headerImportFlags_e {
HEADERIMPORT_COPY = (1 << 0), /* Make copy of blob on import? */
HEADERIMPORT_FAST = (1 << 1), /* Faster but less safe? */
};
typedef rpmFlags headerImportFlags;
Header headerImport(void *blob, unsigned int bsize, headerImportFlags flags);
Header headerRead(FD_t fd, int magicp);
int headerWrite(FD_t fd, Header h, int magicp);
int headerIsEntry(Header h, rpmTagVal tag);
enum headerGetFlags_e {
HEADERGET_DEFAULT = 0, /* legacy headerGetEntry() behavior */
HEADERGET_MINMEM = (1 << 0), /* pointers can refer to header memory */
HEADERGET_EXT = (1 << 1), /* lookup extension types too */
HEADERGET_RAW = (1 << 2), /* return raw contents (no i18n lookups) */
HEADERGET_ALLOC = (1 << 3), /* always allocate memory for all data */
HEADERGET_ARGV = (1 << 4), /* return string arrays NULL-terminated */
};
typedef rpmFlags headerGetFlags;
int headerGet(Header h, rpmTagVal tag, rpmtd td, headerGetFlags flags);
enum headerPutFlags_e {
HEADERPUT_DEFAULT = 0,
HEADERPUT_APPEND = (1 << 0),
};
typedef rpmFlags headerPutFlags;
int headerPut(Header h, rpmtd td, headerPutFlags flags);
int headerPutString(Header h, rpmTagVal tag, const char *val);
int headerPutStringArray(Header h, rpmTagVal tag, const char **val, rpm_count_t size);
int headerPutBin(Header h, rpmTagVal tag, const uint8_t *val, rpm_count_t size);
int headerPutChar(Header h, rpmTagVal tag, const char *val, rpm_count_t size);
int headerPutUint8(Header h, rpmTagVal tag, const uint8_t *val, rpm_count_t size);
int headerPutUint16(Header h, rpmTagVal tag, const uint16_t *val, rpm_count_t size);
int headerPutUint32(Header h, rpmTagVal tag, const uint32_t *val, rpm_count_t size);
int headerPutUint64(Header h, rpmTagVal tag, const uint64_t *val, rpm_count_t size);
int headerAddI18NString(Header h, rpmTagVal tag, const char * string,
const char * lang);
int headerMod(Header h, rpmtd td);
int headerDel(Header h, rpmTagVal tag);
char * headerFormat(Header h, const char * fmt, errmsg_t * errmsg);
void headerCopyTags(Header headerFrom, Header headerTo,
const rpmTagVal * tagstocopy);
HeaderIterator headerFreeIterator(HeaderIterator hi);
HeaderIterator headerInitIterator(Header h);
int headerNext(HeaderIterator hi, rpmtd td);
rpmTagVal headerNextTag(HeaderIterator hi);
RPM_GNUC_DEPRECATED
int headerNVR(Header h,
const char ** np,
const char ** vp,
const char ** rp);
RPM_GNUC_DEPRECATED
int headerNEVRA(Header h,
const char ** np,
uint32_t ** ep,
const char ** vp,
const char ** rp,
const char ** ap);
RPM_GNUC_DEPRECATED
char * headerGetNEVR(Header h, const char ** np );
RPM_GNUC_DEPRECATED
char * headerGetNEVRA(Header h, const char ** np );
/* \ingroup header
* Return (malloc'd) header (epoch:)version-release string.
* @param h header
* @retval np name tag value (or NULL)
* @return (epoch:)version-release string
*/
RPM_GNUC_DEPRECATED
char * headerGetEVR(Header h, const char **np);
char * headerGetAsString(Header h, rpmTagVal tag);
const char * headerGetString(Header h, rpmTagVal tag);
/* \ingroup header
* Return a simple number tag (or extension) from header
* @param h header
* @param tag tag to retrieve
* @return numeric tag value or 0 on failure
*/
uint64_t headerGetNumber(Header h, rpmTagVal tag);
RPM_GNUC_DEPRECATED
rpm_color_t headerGetColor(Header h);
int headerIsSource(Header h);
unsigned int headerGetInstance(Header h);
typedef enum headerConvOps_e {
HEADERCONV_EXPANDFILELIST = 0,
HEADERCONV_COMPRESSFILELIST = 1,
HEADERCONV_RETROFIT_V3 = 2,
} headerConvOps;
int headerConvert(Header h, int op);
#ifdef __cplusplus
}
#endif
#endif /* H_HEADER */